# openssl_spki_export_challenge

(PHP 5 >= 5.6.0, PHP 7)

openssl_spki_export_challenge — Exports the challenge assoicated with a signed public key and challenge

### Description

openssl_spki_export_challenge ( string `&$spkac` ) : string

Exports challenge from encoded signed public key and challenge

### Parameters

`spkac`

  Expects a valid signed public key and challenge

### Return Values

Returns the associated challenge string or NULL on failure.

### Errors/Exceptions

Emits an `E_WARNING` level error if an invalid argument is passed via the `spkac` parameter.

### Examples

Example #1 openssl_spki_export_challenge() example

Extracts the associated challenge string or NULL on failure.

`<?php
$pkey = openssl_pkey_new('secret password');
$spkac = openssl_spki_new($pkey, 'challenge string');
$challenge = openssl_spki_export_challenge(preg_replace('/SPKAC=/', '', $spkac));
?>`

Example #2 openssl_spki_export_challenge() example from <keygen>

Extracts the associated challenge string issued from the <keygen> element

`<?php
$challenge = openssl_spki_export_challenge(preg_replace('/SPKAC=/', '', $_POST['spkac']));
?>
<keygen name="spkac" challenge="challenge string" keytype="RSA">`

### See Also

- openssl_spki_new() - Generate a new signed public key and challenge
- openssl_spki_verify() - Verifies a signed public key and challenge
- openssl_spki_export() - Exports a valid PEM formatted public key signed public key and challenge
- openssl_get_md_methods() - Gets available digest methods
- openssl_csr_new() - Generates a CSR
- openssl_csr_sign() - Sign a CSR with another certificate (or itself) and generate a certificate